#include <timer.h>

unsigned int16 timer_down=0;
unsigned int16 timer_up=0;

#int_TIMER1
void  TIMER1_isr(void) 
{
   if (timer_up > 0)
      timer_up--;
   if (timer_down > 0)
      timer_down--;
}


void main()
{
   setup_adc_ports(sAN0|sAN1);
   setup_adc(ADC_CLOCK_DIV_4);
   setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);      //524 ms overflow

   enable_interrupts(INT_TIMER1);
   enable_interrupts(GLOBAL);
   output_bit(PIN_A2, 0);//.

   set_adc_channel (0); //   0 ( )
   delay_us(50);
   timer_up = read_adc()*2;   
   set_adc_channel (1); //   1 ( .)
   delay_us(50);
   timer_down = read_adc()*2;
   
  
   while(TRUE)
   {
      if(input (PIN_A4)) //  
      {
         set_adc_channel (1); //   1 ( .)
         delay_us(50);
         timer_down = read_adc()*2;
         if (timer_up == 0)
            output_bit(PIN_A2, 1);//.    
      }
      
      else //  
      {      
         set_adc_channel (0); //   0 ( )
         delay_us(50);
         timer_up = read_adc()*2;
         if (timer_down == 0)
         output_bit(PIN_A2, 0);//.                  
      }
   
   }

}
